---
title: Intensive JavaScript
slug: Tools/Performance/Scenarios/Intensive_JavaScript
---
<div>{{ToolsSidebar}}</div><div class="summary">
<p>By default the browser uses a single thread to run all the JavaScript in your page as well as to perform layout, reflows, and garbage collection. This means that long-running JavaScript functions can block the thread, leading to an unresponsive page and a bad user experience.</p>

<p>You can use the <a href="/en-US/docs/Tools/Performance/Frame_rate">Frame rate</a> and <a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a> tools to see when JavaScript is causing performance problems, and to single out the particular functions that need attention.</p>

<p>In this article we'll take an example site whose long-running JavaScript causes responsiveness problems, and apply two different approaches to fixing them. The first is to split long-running functions into pieces and use <code><a href="/en-US/docs/Web/API/window/requestAnimationFrame">requestAnimationFrame</a></code> to schedule each piece, and the second is to run the whole function in a separate thread using a <a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers">web worker</a>.</p>
</div>

<p>If you want to play along you can find the demo website <a class="external external-icon" href="https://mdn.github.io/performance-scenarios/js-worker/index.html">here</a>.</p>

<p>There's also a video version of this walkthrough:</p>

<p>{{EmbedYouTube("Pcc6jQX6JDI")}}</p>

<p>The demo website looks like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/11031/js-worker-demo.png" style="display: block; height: 677px; margin-left: auto; margin-right: auto; width: 1000px;">It has three controls:</p>

<ul>
 <li>a radio button group to control how to run the JavaScript: as a single blocking operation in the main thread, as a series of smaller operations in the main thread using <code>requestAnimationFrame()</code>, or in another thread using a worker.</li>
 <li>a button to run the JavaScript, labeled "Do pointless computations!".</li>
 <li>a button to start and stop some CSS animations. This just gives the browser some background tasks to perform.</li>
</ul>

<p>Leaving the radio button set to "Use blocking call in main thread", make a recording:</p>

<ul>
 <li>press the "Start animations" button</li>
 <li>start recording a performance profile</li>
 <li>press "Do pointless computations!" two or three times</li>
 <li>stop recording the profile</li>
</ul>

<p>Exactly what you see will vary from one machine to another, but it will be something like this:</p>

<p><a id="js-blocking-overview"><img alt="" src="https://mdn.mozillademos.org/files/10891/perf-js-blocking-overview.png" style="display: block; height: 113px; margin-left: auto; margin-right: auto; width: 800px;"></a></p>

<p>The top half of this is the <a href="/en-US/docs/Tools/Performance/UI_Tour#Waterfall_overview">waterfall overview</a>. It gives us a compressed view of the <a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a>, which tells us what kinds of operations the browser is doing during the recording. <a href="/en-US/docs/Tools/Performance/Waterfall#Markers">The pink says that we are mostly performing CSS calculations and possibly reflow</a>: this is the CSS animation that's running throughout the profile. Then there are three solid blocks of orange, representing JavaScript execution, one for each time we pressed the button.</p>

<p>The bottom half, which is correlated with the timeline summary in time, shows <a href="/en-US/docs/Tools/Performance/Frame_rate">frame rate</a>. We can see that frame rate is pretty healthy for most of the recording, but collapses completely whenever we press the button.</p>

<p>We can select one of these periods and have a closer look at it in the main Waterfall view:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10895/perf-js-blocking-waterfall.png" style="display: block; height: 306px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>Here, when we pressed the button, the browser ran a JavaScript function, or series of functions, that blocked the main thread for 71.73ms, or more than four times our frame budget.</p>

<p>Which function, though? By switching to the <a href="/en-US/docs/Tools/Performance/Flame_Chart">Flame Chart</a> view we can find out:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10893/perf-js-blocking-flame-chart.png" style="display: block; height: 230px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>This shows us the JS call stack at this point in the execution. At the top of the stack is a function called <code>calculatePrimes()</code>, and we can see its filename and line number. Here's the code, together with its immediate caller:</p>

<pre class="brush: js">const iterations = 50;
const multiplier = 1000000000;

function calculatePrimes(iterations, multiplier) {
  var primes = [];
  for (var i = 0; i &lt; iterations; i++) {
    var candidate = i * (multiplier * Math.random());
    var isPrime = true;
    for (var c = 2; c &lt;= Math.sqrt(candidate); ++c) {
      if (candidate % c === 0) {
          // not prime
          isPrime = false;
          break;
       }
    }
    if (isPrime) {
      primes.push(candidate);
    }
  }
  return primes;
}

function doPointlessComputationsWithBlocking() {
  var primes = calculatePrimes(iterations, multiplier);
  pointlessComputationsButton.disabled = false;
  console.log(primes);
}
</pre>

<p>We're just running a (very inefficient) primality test 50 times, for some quite large numbers.</p>

<h2 id="Using_requestAnimationFrame">Using requestAnimationFrame</h2>

<p>In the first attempt at fixing this, we'll split up the function into a number of much smaller self-contained functions, and schedule each one using <code><a href="/en-US/docs/Web/API/window/requestAnimationFrame">requestAnimationFrame()</a></code>.</p>

<p><code>requestAnimationFrame()</code> tells the browser to run the given function in each frame, just before it performs a repaint. As long as each function is reasonably small, the browser should be able to keep inside its frame budget.</p>

<p>It's pretty simple to split up <code>calculatePrimes()</code>: we will just calculate primality for each number in a separate function:</p>

<pre class="brush: js">function doPointlessComputationsWithRequestAnimationFrame() {

  function testCandidate(index) {
    // finishing condition
    if (index == iterations) {
      console.log(primes);
      pointlessComputationsButton.disabled = false;
      return;
    }
    // test this number
    var candidate = index * (multiplier * Math.random());
    var isPrime = true;
    for (var c = 2; c &lt;= Math.sqrt(candidate); ++c) {
      if (candidate % c === 0) {
          // not prime
          isPrime = false;
          break;
       }
    }
    if (isPrime) {
      primes.push(candidate);
    }
    // schedule the next
    var testFunction = testCandidate.bind(this, index + 1);
    window.requestAnimationFrame(testFunction);
  }

  var primes = [];
  var testFunction = testCandidate.bind(this, 0);
  window.requestAnimationFrame(testFunction);
}</pre>

<p>Let's test this version out: select the radio button labeled "Use requestAnimationFrame" and capture another profile. This time, the recording should look something like this:</p>

<p><a id="js-raf-overview"><img alt="" src="https://mdn.mozillademos.org/files/10897/perf-js-raf-overview.png" style="display: block; height: 112px; margin-left: auto; margin-right: auto; width: 800px;"></a></p>

<p>This is exactly what we might have expected to see. Instead of <a href="#js-blocking-overview">a single solid orange block</a>, each button-press shows up as a long sequence of very short orange blocks. The orange blocks appear one frame apart, and each one represents one of the functions called from <code>requestAnimationFrame()</code>. Note that there are only two button-presses in this profile.</p>

<p>The function calls are interleaved with the pink blocks from the CSS animation, and each function is short enough that the browser can handle it without the overall frame rate dropping.</p>

<p>Using <code>requestAnimationFrame</code> worked to solve the responsiveness problem here, but there are a couple of potential problems with it:</p>

<ul>
 <li>it can be difficult to split up a long-running function into separate self-contained functions. Even this very simple case produced more complex code.</li>
 <li>the split-up version takes much longer to run. In fact we can be quite precise about how long it takes: there are 50 iterations, and the browser is producing about 60 frames per second. So it will take almost a second to run all the computations, and that's visible in both the user experience and in the profile.</li>
</ul>

<h2 id="Using_web_workers">Using web workers</h2>

<p>In this version we'll try to fix the problem using a web worker. Web workers enable you to run JavaScript in a separate thread. The main thread and the worker thread can't call each other directly, but communicate using an asynchronous messaging API.</p>

<p>The main thread code would look something like this:</p>

<pre class="brush: js">const iterations = 50;
const multiplier = 1000000000;

var worker = new Worker("js/calculate.js");

function doPointlessComputationsInWorker() {

  function handleWorkerCompletion(message) {
    if (message.data.command == "done") {
      pointlessComputationsButton.disabled = false;
      console.log(message.data.primes);
      worker.removeEventListener("message", handleWorkerCompletion);
    }
  }

  worker.addEventListener("message", handleWorkerCompletion, false);

  worker.postMessage({
    "multiplier": multiplier,
    "iterations": iterations
  });
}</pre>

<p>The main difference here, compared with the original, is that we need to:</p>

<ul>
 <li>create a worker</li>
 <li>send it a message when we are ready to calculate</li>
 <li>listen for a message called "done", which indicates that the worker has finished.</li>
</ul>

<p>Then we need a new file "calculate.js", that looks like this:</p>

<pre class="brush: js">self.addEventListener("message", go);

function go(message) {
  var iterations = message.data.iterations;
  var multiplier = message.data.multiplier;
  primes = calculatePrimes(iterations, multiplier);

  self.postMessage({
    "command":"done",
    "primes": primes
  });
}

function calculatePrimes(iterations, multiplier) {
  var primes = [];
  for (var i = 0; i &lt; iterations; i++) {
    var candidate = i * (multiplier * Math.random());
    var isPrime = true;
    for (var c = 2; c &lt;= Math.sqrt(candidate); ++c) {
      if (candidate % c === 0) {
          // not prime
          isPrime = false;
          break;
       }
    }
    if (isPrime) {
      primes.push(candidate);
    }
  }
  return primes;
}</pre>

<p>In the worker, we have to listen for a message telling us to start, and send a "done" message back when we are done. The code that actually performs the computations is exactly the same as the original code.</p>

<p>So how does this version perform? Switch the radio button to "Use a worker", and capture a new profile. You should see something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10899/perf-js-worker-overview.png" style="display: block; height: 112px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>In this profile we pushed the button three times. <a href="#js-blocking-overview">Compared with the original</a>, each button-press is visible in the overview as two very short orange markers:</p>

<ul>
 <li>the <code>doPointlessComputationsInWorker()</code> function that handles the click event and starts the worker's processing</li>
 <li>the <code>handleWorkerCompletion()</code> function that runs when the worker calls "done".</li>
</ul>

<p>In between, the worker runs all the primality tests, and it doesn't seem to have any effect at all on the responsiveness of the main thread. This might seem unlikely, but because workers run in a separate thread, they can take advantage of multi-core processors, which a single-threaded web site can't.</p>

<p>The main limitation of web workers is that DOM APIs are not available to code running in a worker.</p>

